//*********************************
//ģ:UART.C
//:2011-05-10
//:ں
//:
//*********************************

//**********ͷļ***************
#define BoTeLv 9600  // BoTeLv
#include "config.h"
#include "uart.h"

//*********************************
//UART0_Init
//UART0ʼ
//룺
//
//ú
//
//*********************************
void UART0_Init (void)		
{
   UINT16 Fdiv;
   PINSEL0 = 0x00000005;// I/OӵUART0
   PINSEL1 = 0x00000000;  
   U0LCR = 0x83;	// ֻеDLAB = 1ʱſ޸Ĳ
   Fdiv = (Fpclk / 16)/ BoTeLv;// ޸Ĳ
   U0DLM = Fdiv / 256;	//װ벨صļĴĸ8λ					
   U0DLL = Fdiv % 256;	//װ벨صļĴĵ8λ
   U0LCR = 0x03;
}

//*********************************
//UART0_GetChar
//UART0һַ
//룺
//
//ú
//
//*********************************
UINT8 UART0_GetChar ( void )
{
  UINT8 Rcv_Data;
  while((U0LSR&0x01)==0);  //ȴЧ
  Rcv_Data=U0RBR;          //ȡ
  return(Rcv_Data);
}

//*********************************
//UART0_GetString
//UART0һַ
//룺*s-ַָ n-ַ
//
//ú
//         UART0_GetString(*s,n)
//
//*********************************
void UART0_GetString ( UINT8 *s,UINT32 n )
{
  for(;n>0;n++)
  {
    *s++=UART0_GetChar();
  }
}

//*********************************
//UART0_PutChar
//UART0һַ
//룺data-͵ַ
//
//ú
//
//*********************************

void UART0_PutChar ( UINT32 data)
{
  U0THR = data;		// 
  while( (U0LSR&0x40)==0 );// ȴݷ
}

//*********************************
//UART0_PutString
//UART0һַ
//룺*str-͵ַ
//
//ú
//         UART0_PutChar(*s,n)
//
//*********************************
void  UART0_PutString(UINT8 *str)
{
  while(*str !='\0')
  {
    UART0_PutChar(*str++);
  }
}

//*********************************
//PLL_Init
//໷ʼ
//룺
//
//ú
//
//*********************************
void PLL_Init(void)
{
  PLLCON = 1;
  VPBDIV = 1;
  PLLCFG = 0x24; //5Ƶ            
  PLLFEED = 0xaa;
  PLLFEED = 0x55;
  while((PLLSTAT & (1 << 10)) == 0);
  PLLCON = 3;
  PLLFEED = 0xaa;
  PLLFEED = 0x55;	
}

